#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>

#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdlib.h>

#include <string>
#include <vector>
using namespace std;



typedef int (WINAPI *VeryPDF_PSToPDFFunc)(LPCTSTR lpCommand);
VeryPDF_PSToPDFFunc VeryPDF_PSToPDF = NULL;

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

static DWORD WINAPI Launch_PS2PDFSDK_Thread(LPVOID pParam)
{
	char *lpPSFileName = (char *)pParam;
	if(lpPSFileName == NULL)
		return 0;
	
	int iThreadID = GetCurrentThreadId();
	char szOutName[MAX_PATH];
	char szFileExt[MAX_PATH];
	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[MAX_PATH],ext[_MAX_EXT];


	sprintf(szFileExt,"_thread_id_%d",iThreadID);
	_splitpath(lpPSFileName, drive, dir, fname, ext );
	strcat(fname, szFileExt);
	_makepath(szOutName, drive, dir, fname, ".pdf");

	char szCommandLine[2048] = {0};
	sprintf(szCommandLine,"ps2pdf -$ XXXXXXXXXXXXXX \"%s\" \"%s\"", lpPSFileName, szOutName);

	char path[_MAX_PATH];
	HINSTANCE hPS2PDF = NULL;
	BOOL bRet;
	//GetModulePath(path,"ps2pdf_x64.dll");
	GetModulePath(path,"ps2pdfsdk.dll");
	hPS2PDF = LoadLibrary(path);
	if(hPS2PDF == NULL)
	{
		printf("[Thread %d] Load '%s' file failed.\n", iThreadID, path);
		return FALSE;
	}
	printf("[Thread %d] Load '%s' file successful.\n", iThreadID, path);
	VeryPDF_PSToPDF=(VeryPDF_PSToPDFFunc)GetProcAddress(hPS2PDF,"VeryPDF_PSToPDF");
	if(VeryPDF_PSToPDF==NULL)
		return FALSE;
	printf("[Thread %d] Get 'VeryPDF_PSToPDF' function successful.\n", iThreadID);
	bRet = VeryPDF_PSToPDF(szCommandLine);
	FreeLibrary(hPS2PDF);
	printf("[Thread %d] Execute function successful.\n", iThreadID);

	return 0;
}
void TestForMultiThread(char *lpszPSFileName)
{
#define MAX_THREADS 10
	HANDLE aryHandles[MAX_THREADS] = {0};
	for(int i = 0; i < MAX_THREADS; i++)
	{
		DWORD dwThreadId;
		aryHandles[i] = CreateThread(NULL,0,Launch_PS2PDFSDK_Thread, strdup(lpszPSFileName), 0, &dwThreadId);
	}
	WaitForMultipleObjects(MAX_THREADS, aryHandles, TRUE, INFINITE);
}

void main(int argc, char *argv[])
{
	if(argc != 2)
	{
		printf("\"%s\" test.ps\n", argv[0]);
		return;
	}
	TestForMultiThread(argv[1]);
	printf("Press any key to continue...\n");
	getchar();
}